мир.платформы = {
    умолчание: {
        x: 100,
        y: 100,
        ширина: 40,
        высота: 20,
        цвет: "#ff0000",
        статика: true,
    },
    задано: {},
    тела: {},
    элементы: {},
    свойстваТела: ["x", "y", "ширина", "высота", "статика"],
    обновить: обновитьПлатформы,
};


// // // //


мир.ключники.push(function(ключ, путь, значение){
    if (!ключ.startsWith("платформы"))
    {
        return;
    }

    var имя = путь[1];
    var свойство = путь[2];

    сохранитьЗаданноеЗначение(имя, свойство, значение);
    пересоздатьТело(имя, свойство, значение);


    var за = мир.платформы.задано[имя];
    var умолчание = мир.платформы.умолчание;
    var ширина = за["ширина"] ? за["ширина"] : умолчание["ширина"];
    var высота = за["высота"] ? за["высота"] : умолчание["высота"];

    // Создать div.
    if (!(имя in мир.платформы.элементы))
    {
        var элемент = document.createElement("div");
        элемент.style.position = "absolute";
        элемент.style.display = "block";
        элемент.style.backgroundColor = умолчание["цвет"];
        элемент.style.width = `${ширина}px`;
        элемент.style.height = `${высота}px`;
        элемент.style.transformOrigin = `center`;
        document.body.appendChild(элемент);
        мир.платформы.элементы[имя] = элемент;

    }

    // Обновить div.
    var элемент = мир.платформы.элементы[имя];
    if (свойство == "ширина")
    {
        элемент.style.width = `${ширина}px`;
    }
    else if (свойство == "высота")
    {
        элемент.style.height = `${высота}px`;
    }
    else if (свойство == "цвет")
    {
        элемент.style.backgroundColor = за["цвет"];
    }

});


// // // //


function обновитьПлатформы()
{
    for (var имя in мир.платформы.тела)
    {
        var тело = мир.платформы.тела[имя];
        if (тело.isSleeping)
        {
            continue;
        }
        var элемент = мир.платформы.элементы[имя];
        let x = тело.position.x - элемент.offsetWidth / 2;
        let y = тело.position.y - элемент.offsetHeight / 2;
        let угол = тело.angle;
        элемент.style.transform = `translate(${x}px, ${y}px) rotate(${угол}rad)`;
    }
}

function сохранитьЗаданноеЗначение(имя, свойство, значение)
{
    if (!(имя in мир.платформы.задано))
    {
        мир.платформы.задано[имя] = {};
    }
    мир.платформы.задано[имя][свойство] = значение;
console.debug("задано", мир.платформы.задано[имя]);
}

function пересоздатьТело(имя, свойство, значение)
{
    if (!мир.платформы.свойстваТела.includes(свойство))
    {
        return;
    }

    // Удалить физическое тело.
    if (имя in мир.платформы.тела)
    {
        var тело = мир.платформы.тела[имя];
        Matter.Composite.remove(мир.физика.движок.world, тело);
    }
    // Пересоздать физическое тело.
    var за = мир.платформы.задано[имя];
    var ум = мир.платформы.умолчание;

    var x = за["x"] ? за["x"] : ум["x"];
    var y = за["y"] ? за["y"] : ум["y"];
    var ширина = за["ширина"] ? за["ширина"] : ум["ширина"];
    var высота = за["высота"] ? за["высота"] : ум["высота"];
    var свойства = {
        isStatic: ("статика" in за) ? за.статика : ум.статика,
    };

    var тело = Matter.Bodies.rectangle(x, y, ширина, высота, свойства);
console.debug("создать тело", тело);
    Matter.Composite.add(мир.физика.движок.world, тело);
    мир.платформы.тела[имя] = тело;
}
